
#include "maretud.h"
#include "mtide.h"

enum sources {ENREG, MBRUTE, MRECTIF, MABRUTE, MARECTIF};
enum actions {DETPERIODE, DETONDE, GRAPHTIDE};
enum graphtides {GT_RENDER,GT_PREDICT,GT_ENR,GT_ALL};

#define SOURCE ENREG
#define ACTION GRAPHTIDE
#define GTWHAT GT_ALL

#define TABPREC 3600			// Precision heure
#define LARGX 640			// Largeur de la Fenetre
#define HAUTY 480			// Hauteur Fenetre
#define SCROLLBAR 20			// Nombre de points d'une barre de dfilement
#define HAUTMENU 40			// Hauteur du menu
#define MILY 250			// Milieu dec le Fenetre
#define COEFY 30			// Coefficient multiplicateur

#define LOGNAME "MarEtud.log"

int NUMJOURS = 365;			// Nombre de jours de l'etude
long NUMPOINTS = (long)24*NUMJOURS;	// Nombre de points tableau.


enum actions Action = ACTION;
enum sources Source = SOURCE;
enum graphtides GTWhat = GTWHAT;

const DOUBLE det_deb_tab[4]={11.75,23,5,3};
const DOUBLE det_fin_tab[4]={13,25,37,50};

CHAR NameFichierOndes[300]="BREST.TID";
CHAR NameFichierImporter[300]="BREST.TXT";

CHAR localite[100]="Brest";
INT YearOfDebut = 1996;

const INT NumOndeAjouter = 37;
const CHAR *OndeAjouterName [NumOndeAjouter] =
  {"M2 : Onde Lunaire semi-diurne. 12h25m28s",                    // 0
   "S2 : Onde Solaire semi-diurne. 12h",                          // 1
   "N2 : Onde Lunaire elliptique majeur semi-diurne. 12h39m",     // 2
   "K2 : Onde Sidrale semi-diurne. 11h58m",                      // 3
   "L2 : Onde Lunaire eliptique mineur semi-diurne. 12h11m",      // 4
   "O1 : Onde Lunaire diurne. 25h49m",                            // 5
   "K1 : Onde Sidrale diurne. 23h56m",                           // 6
   "P1 : Onde Solaire diurne. 24h04m",                            // 7
   "Mf : Onde Lunaire semi-mensuelle. 13j 16h",                   // 8
   "Mm : Onde Lunaire mensuelle. 27j 13h",                        // 9
   "Ssa: Onde Solaire semi-annuelle. 182j",                       // 10
   "J1 : Onde diurne. 23h05m.",                                   // 11
   "M1 : Onde Lunaire diurne. 24h50m.",                           // 12
   "M3 : Onde Lunaire tiers-diurne. 8h16m.",                      // 13
   "M4 : Onde Lunaire quart-diurne. 6h12m.",                      // 14
   "M6 : Onde Lunaire au sixime. 4h08m.",                        // 15
   "M8 : Onde Lunaire au huitime. 3h06m.",                       // 16
   "2N2: Onde Lunaire elliptique deuxieme. 12h54m.",              // 17
   "OO1: Onde diurne. 22h18m.",                                   // 18
   "Q1 : Onde diurne. 26h52m.",                                   // 19
   "2Q1: Onde diurne deuxieme. 28h00m.",                          // 20
   "R2 : Onde semi-diurne. 11h59m.",                              // 21
   "S1 : Onde solaire diurne. 24h00m.",                           // 22
   "S4 : Onde solaire quart-diurne. 6h00m.",                      // 23
   "S6 : Onde solaire au sixime. 4h00m.",                        // 24
   "T2 : Onde solaire semi-diurne autre. 12h00m.",                // 25
   "LA2: Onde LAMBDA2 semi-diurne. 12h13m.",                      // 26
   "MU2: Onde MU2 semi-diurne. 12h52m.",                          // 27
   "NU2: Onde NU2 semi-diurne. 12h37m.",                          // 28
   "RH1: Onde RHO1 semi-diurne. 26h43m.",                         // 29
   "MK3: Onde MK3 tiers diurne. 8h10m.",                          // 30
   "2M3: Onde 2MK3 tiers diurne seconde. 8h23m.",                 // 31
   "MN4: Onde quart dirune. 6h16m.",                              // 32
   "MS4: Onde quart diurne. 6h06m.",                              // 33
   "2SM: Onde 2SM2 semi-diurne. 11h36m.",                         // 34
   "MSF: Onde LLONG terme seconde. 14j18h.",                       // 35
   "SA : Onde semi-annuelle. 182j."};                              // 36
     
const LDOUBLE OndeAjouterPeriode [NumOndeAjouter] =
  {12.4206012,							// 0
   12.0000000,                                                  // 1
   12.6583482,                                                  // 2
   11.9672348,                                                  // 3
   12.1916202,                                                  // 4
   25.8193417,                                                  // 5
   23.9344697,                                                  // 6
   24.0658902,                                                  // 7
   327.858969,                                                  // 8
   661.309205,                                                  // 9
   4382.90521,                                                  // 10
   23.09847677,                                                 // 11
   24.83324836,                                                 // 12
   8.280400814,                                                 // 13
   6.21030061,                                                  // 14
   4.140200402,                                                 // 15
   3.105150302,                                                 // 16
   12.90537448,                                                 // 17
   22.3060742,                                                  // 18
   26.86835667,                                                 // 19
   28.00622255,                                                 // 20
   11.98359578,                                                 // 21
   24.00000000,                                                 // 22
   6.000000000,                                                 // 23
   4.000000000,                                                 // 24
   12.0164492,                                                  // 25
   12.22177415,                                                 // 26
   12.87175763,                                                 // 27
   12.62600441,                                                 // 28
   26.7230533,                                                  // 29
   8.177139947,                                                 // 30
   8.38630297,                                                  // 31
   6.269173909,                                                 // 32
   6.103339279,                                                 // 33
   11.60695156,                                                 // 34
   354.3670522,                                                 // 35
   8765.82109};                                                 // 36

const INT NumOndeRempl [5] = {0,1,2,5,6};
const INT NumOndeImportance [NumOndeAjouter] =
  {0,1,2,3,27,28,4,5,6,36,14,17,25,33,15,26,7,32,13,19,34,22,8,10,11,9,16,35,12,18,20,21,23,24,29,30,31};

INT *tab;			// Tableau
LDOUBLE dop;				// DetOndePeriode

const CHAR *Jours[7]={"Dimanche ","   Lundi ","   Mardi ","Mercredi ","   Jeudi ","Vendredi ","  Samedi "};
const CHAR *Jours2[7]={"Dimanche ","Lundi ","Mardi ","Mercredi ","Jeudi ","Vendredi ","Samedi "};
const CHAR *Mois[12]={" janvier"," fvrier"," mars"," avril"," mai"," juin"," juillet"," aot"," septembre"," octobre"," novembre"," dcembre"};
const CHAR *Mois2[12]={"Janvier","Fvrier","Mars","Avril","Mai","Juin","Juillet","Aout","Septembre","Octobre","Novembre","Dcembre"};
 
LDOUBLE Z0;		        // Niveau moyen
INT NumOnde=0;			// Nombre d'ondes correctes
INT NumOndeBis;			// Numero de l'onde a traiter


struct tonde ondes [NUMCONST];

LDOUBLE det_deb=11.8,det_fin=13.0;

INT OndeAModifier = 0;	   

BOOL AxeTemps = TRUE;
BOOL AxeHauteur = TRUE;
BOOL Horaires = TRUE;
BOOL CFourier = TRUE;
BOOL Ver_FFT = FALSE;

time_t time_of_debut,decal_time=0, worktime;
struct tm rtime;

BOOL ok_tab = FALSE;		// Tableau pas pret

INT screen[640];		// Affichage;

FILE *flog;

HINSTANCE hInst;
HWND MyWin;
HDC MyDC;
HPEN hPRed, hPBlue, hPGreen, hPBlack;

// LOAD DATA : Initialise les donnees (pour l'instant 5 ondes de tests)
void loaddata (void)
{
 Z0=6.02;
 ondes[0].speed=(28.9841042/3600)*M_PI/180; ondes[0].ampl=2.06; ondes[0].etab= 99*M_PI/180; strcpy (ondes[0].name,"Onde lunaire semi-diurne.");	// M2
 ondes[1].speed=(30.0000000/3600)*M_PI/180; ondes[1].ampl=0.75; ondes[1].etab=139*M_PI/180; strcpy (ondes[1].name,"Onde solaire semi-diurne.");	// S2
 ondes[2].speed=(28.4397295/3600)*M_PI/180; ondes[2].ampl=0.42; ondes[2].etab= 80*M_PI/180; strcpy (ondes[2].name,"Onde lunaire elliptique semi-diurne.");	// N2
 ondes[3].speed=(13.9430356/3600)*M_PI/180; ondes[3].ampl=0.07; ondes[3].etab=324*M_PI/180; strcpy (ondes[3].name,"Onde lunaire diurne.");	// O1
 ondes[4].speed=(15.0000000/3600)*M_PI/180; ondes[4].ampl=0.06; ondes[4].etab= 69*M_PI/180; strcpy (ondes[4].name,"Onde lunaire diurne.");	// K1
 NumOnde = 0;
}

LDOUBLE get_tide (LDOUBLE t);		// Predef pour tide_load

// TIDE_LOAD : Renvoie la hauteur de la maree : selection de la source
DOUBLE tide_load (LDOUBLE t, INT onde=0)
{
 switch (Source)
  {
   case ENREG	: return (get_tide(t)); break;
   case MBRUTE	: return (tide(t)); break;
   case MRECTIF	: return (tide(t,onde)); break;
   case MABRUTE	: return (tide(60*(LLONG)(t/60))); break;
   case MARECTIF: return (tide(60*(LLONG)(t/60),onde)); break;
  }
}

LDOUBLE det_niv (BOOL Quiet);	// Predef


// INIT_TAB : Initialise le tableau avec les valeurs mesures
void init_tab ()
{
 FILE *tabfile;
 INT compt,year,jours;
 if ((tabfile = fopen(NameFichierImporter,"r")) == NULL)
   {
    /*MessageBox (MyWin,"Erreur ouverture donnees.","Pb !",MB_OK); exit (10);*/
    NUMJOURS = 365;
    NUMPOINTS = (LLONG)NUMJOURS*24;
    tab = (INT *)malloc((NUMPOINTS+1)*2);
    rtime.tm_year = YearOfDebut - 1900;
    rtime.tm_mon = 0;
    rtime.tm_mday = 1;
    rtime.tm_hour = 0;
    rtime.tm_min = 0;
    rtime.tm_sec = 0;
    time_of_debut = mktime (&rtime);
    for (compt=0;compt<NUMPOINTS;compt++)
    {
     tab[compt]=0;
    }
   }
  else
   {
    fgets (localite,100,tabfile);
    fscanf (tabfile,"%i\n",&year);
    fscanf (tabfile,"%i\n\n",&jours);
    NUMJOURS = jours;
    NUMPOINTS = (LLONG)jours*24;
    tab = (INT *)malloc((NUMPOINTS+1)*2);
    YearOfDebut = year;
    rtime.tm_year = year - 1900;
    rtime.tm_mon = 0;
    rtime.tm_mday = 1;
    rtime.tm_hour = 0;
    rtime.tm_min = 0;
    rtime.tm_sec = 0;
    time_of_debut = mktime (&rtime);
    for (compt=0;compt<NUMPOINTS;compt++)
    {
     fscanf (tabfile,"%d\n",&(tab[compt]));
    }
    fclose (tabfile);
    det_niv(TRUE);
   }
}

// DET_NIV : Determine le niveau moyen de la maree
LDOUBLE det_niv (BOOL Quiet=FALSE)
{
 LLONG i;
 LDOUBLE resu;
 CHAR temp[100];
 resu = 0.0;
 for (i=0;i<NUMPOINTS;i++)
 {
  resu+=get_tide(i*PRECISION);
 }
 resu /= NUMPOINTS;
 if (Quiet == FALSE)
 {
  sprintf (temp,"Niveau moyen : %Lf \n\n",resu);
  MessageBox (MyWin,temp,"Dtermination du niveau moyen",MB_OK+MB_APPLMODAL+MB_ICONINFORMATION);
  fprintf (flog,"Niveau moyen : %Lf \n\n",resu);
 }
 Z0 = resu;
 return (resu);
}

// Renvoie la periode de l'onde numonde
LDOUBLE det_onde_num (INT onde)
{
 ondes[NumOnde]=det_onde_periode (OndeAjouterPeriode[NumOndeRempl[onde]]*3600);
 strcpy (ondes[NumOnde].name,OndeAjouterName[NumOndeRempl[onde]]);
 fprintf (flog,"Dtermination de l'onde %i :\n - Priode : %Lf\n - Amplitude : %Lf\n - Etablissement : %Lf\n%s\n",onde,(2.*M_PI/ondes[NumOnde].speed)/3600,ondes[NumOnde].ampl,ondes[NumOnde].etab,ondes[NumOnde].name);
 return (ondes[NumOnde++].ampl);
}

// Renvoie la periode de l'onde numonde
LDOUBLE det_onde_num_tout (INT onde)
{
 ondes[NumOnde]=det_onde_periode (OndeAjouterPeriode[NumOndeImportance[onde]]*3600);
 strcpy (ondes[NumOnde].name,OndeAjouterName[NumOndeImportance[onde]]);
 fprintf (flog,"Dtermination de l'onde %i :\n - Priode : %Lf\n - Amplitude : %Lf\n - Etablissement : %Lf\n%s\n",onde,(2.*M_PI/ondes[NumOnde].speed)/3600,ondes[NumOnde].ampl,ondes[NumOnde].etab,ondes[NumOnde].name);
 return (ondes[NumOnde++].ampl);
}

void det_precis (DOUBLE p, DOUBLE pas)
{
 struct tonde maxret;
 CHAR temp[100];
 maxret = det_precis_func (p,pas,0.00001);
 sprintf (maxret.name,"Onde dtemine de priode %Lf",(2.*M_PI/maxret.speed)/3600);
 ondes[NumOnde++]=maxret;
 sprintf (temp,"L'onde suivante a te ajoute :\n - Priode : %Lf\n - Amplitude : %Lf\n - Etablissement : %Lf\n%s\n",(2.*M_PI/maxret.speed)/3600,maxret.ampl,maxret.etab,maxret.name);
 fprintf (flog,"%s\n",temp);
 MessageBox (MyWin, temp, "Slection d'une onde",MB_OK+MB_APPLMODAL+MB_ICONINFORMATION);
}

// DET_PERIODE_FFT : Determine la priode par FFT
void det_periode_fft (void)
{
 struct tonde maxret;
 CHAR temp[100];
 maxret = det_max_periode();
 sprintf (maxret.name,"Onde dtemine de priode %Lf",(2.*M_PI/maxret.speed)/3600);
 ondes[NumOnde++]=maxret;
 sprintf (temp,"L'onde suivante a t ajoute :\n - Priode : %Lf\n - Amplitude : %Lf\n - Etablissement : %Lf\n%s\n",(2.*M_PI/maxret.speed)/3600,maxret.ampl,maxret.etab,maxret.name);
 fprintf (flog,"%s\n",temp);
 MessageBox (MyWin, temp, "Slection d'une onde",MB_OK+MB_APPLMODAL+MB_ICONINFORMATION);
}

// DET_PERIODE : Determine les periodes possibles
void det_periode (LLONG debut,LLONG fin, INT vit)
{
 LLONG pos,pis;
 LLONG pas;
 INT ok=1;
 DOUBLE ampl,oldamp=10.,olddeph,deph;
 DOUBLE maxampl=-10,maxspeed,maxdeph;
 struct tonde ret, oldret;
 pas = (10>((fin-debut)/640))?((fin-debut)/640):10;
 for (pos=debut;pos<fin;pos+=pas)
 {
  kbhit(); //Pour win95
  pis = (INT)((DOUBLE)(pos - debut)/(fin-debut)*640);
  ret = det_onde_periode((LDOUBLE)(pos));
  ampl = ret.ampl;
  deph = ret.etab;
  screen [pis]=480-(INT)(60*ampl+100);
  LineTo(MyDC, pis,screen[pis]);
  if (oldamp < ampl) {ok=0;}
  if (((oldamp > 0.04) && (oldamp>ampl)) && (ok==0))
    {
     fprintf (flog,"Onde reperee pour T = %f avec %f\n",((DOUBLE)(pos)/3600),oldamp);
     ok = 1;
     if (oldamp>maxampl)
      {
       maxampl = oldamp;
       maxdeph = olddeph;
       maxspeed = 2.*M_PI/(pos);
      }
    }
  oldamp = ampl;
  olddeph = deph;
 }
 fprintf (flog,"\nOnde  preciser : %i %f %f %f\n\n",NumOnde,maxspeed,maxampl,maxdeph);
 det_precis (2.*M_PI/maxspeed,pas);
}


// DET_MAREE : Renvoie la date de la mare la plus proche.
LDOUBLE det_maree (LDOUBLE x)
{
}
 
// GRAPH_TIDE : Affiche la hauteur des marees sur njours jours a l'ecran.
void graph_tide (INT njours)
{
 LLONG t,h;
 DOUBLE d,ancd=1;
 for (t=0;t<640;t++)
 {
  h = t*135*njours;
  LineTo (MyDC,t,480-(INT)(60*tide(h))+100);
 }
}

// ACTIONMAKER : Procedure d'action
void actionmaker ()
{
 SetCursor(LoadCursor(NULL, IDC_WAIT));
 MyDC = GetDC (MyWin);
 if (Action == DETPERIODE)
  { 
   det_periode((LLONG)(det_deb*3600.),(LLONG)(det_fin*3600),1); 	// De 6h a 36h
  }
 if (Action == DETONDE)  { det_onde_num(NumOndeBis); }
 SetCursor(LoadCursor(NULL, IDC_ARROW));
 InvalidateRect (MyWin,NULL,TRUE);
 UpdateWindow(MyWin);
}

// Procedure CONV : TRANSFORME Horaires de mares -> Releve horaires		
/* Format du fichier source
Nom du Port\n
Anne
Nombre de jours

hh\tmm\thauteur en m\n (en . et non en , cf Excel)		*au max 8*NbJours
<EOF>
*/

/* Format de sortie
Nom du Port\n
Anne
Nombre de jours

hauteur par heure en cm (entier) 	*NbJours*24heures
*/
void Conv ()
{
 float *tab,*heur;
 float ch1,ch2,tim1,tim2,resu,tmpfl;
 int nbjours,htmp,ohtmp,mtmp,omtmp,stopp;
 long i,ct;
 char temp[100];
 fpos_t *curpos;
 FILE *fin,*fout,*ferr;
 if ((MessageBox (NULL,"Convertit horaires de mares -> Relevs horaires.\n\nFichier source : SOURCE.TXT\nFichier cible : SORTIE.TXT\nFichier de Rapport : REPORT.TXT\n\nCommencer le traitement ?","Convertisseur pour MarEtud",MB_YESNO)!=IDNO))
 {
  if (((fin=fopen("source.txt","r"))!=NULL) &&
      ((fout=fopen("sortie.txt","w"))!=NULL) &&
      ((ferr=fopen("report.txt","w"))!=NULL))
  {
   fputs(fgets (temp,100,fin),fout);		// Lit Ecrit nom
   fputs(fgets (temp,100,fin),fout);		// Lit Ecrit date
   fscanf(fin,"%i\r\n\r\n",&nbjours);
   fprintf (fout,"%i\r\n\r\n",nbjours);
   tab = (float *)malloc(4*8*nbjours);
   heur = (float *)malloc(4*8*nbjours);
   stopp = 0;
   fgets (temp,100,fin);
   if (sscanf (temp,"%i\t%i\t%f\n",&htmp,&mtmp,&tmpfl)==0) {stopp=-1;}
   tab[0]=tmpfl;
   heur[0]=htmp+(float)mtmp/60;
   i=0;
   while ((!feof(fin)) && (!stopp))
   {
    i++;
    int res;
    ohtmp=htmp; omtmp=mtmp;
    fgets (temp,100,fin);
    if ((res=sscanf (temp,"%i\t%i\t%f\n",&htmp,&mtmp,&tmpfl))==0) {stopp=-1;}
    tab[i]=tmpfl;
    if (ohtmp>htmp)
	  { heur[i] = heur[i-1]+24+htmp-ohtmp+(float)(mtmp-omtmp)/60; }
     else { heur[i] = heur[i-1]   +htmp-ohtmp+(float)(mtmp-omtmp)/60; }
    fprintf (ferr,"%f\t%i\t%i\t%li\t%f\n",heur[i],htmp,mtmp,i,heur[10]);
   }
   fclose (fin);
   for (int j=0;j<i;j++) {fprintf (ferr,"%f\n",heur[j]);  }
   ct=0; ch1=tab[1]; ch2=tab[0]; tim1=heur[1]; tim2=heur[0];
   for (i=-1;i<24*nbjours-1;i++)
   {
    while (i>tim2)
     {
      ct++;
      ch1=tab[ct-1];
      tim1=heur[ct-1];
      ch2=tab[ct];
      tim2=heur[ct];
      fprintf (ferr,"--> %li\t%f\t%f\t%f\t%f\n",i,tim1,tim2,ch1,ch2);
     }
    fprintf (ferr,"%li\t%f\t%f\t%f\t%f\n",i,tim1,tim2,ch1,ch2);
    resu = (ch1+(ch2-ch1)*sin(M_PI_2*(i-tim1)/(tim2-tim1)));
    fprintf (fout,"%i\n",(int)(resu*100));
   }
   fclose (ferr);
   fclose (fout);
   MessageBox (NULL,"Conversion termine.","Convertisseur",MB_OK);
  }
  else
  {
   MessageBox (NULL,"Erreur lors de l'ouverture des fichiers.","Convertisseur",MB_OK+MB_ICONSTOP);
  }
 }
}

// Procedure principale
void main2 ()
{
 loaddata();
 init_tab();
 det_niv (TRUE);
 ok_tab = TRUE;
 actionmaker();
}

void main ()
{
 main2();
}


// CALCULEHORAIRES : Calcule les horaires de mares		     //	!!!!!!!!! ENCOURS
BOOL CALLBACK DialogProcCalcHor(HWND hwndDlg, UINT msg, WPARAM wParam, LPARAM lParam)
{
 INT i,curday,o,u;
 struct tm tmr;
 time_t curtime;
 CHAR temp[100];
 LLONG debut,fin,pen;
 LDOUBLE dto, dtn, hm, bm, mm, c1,c2;
 CHAR bm1[6]="      ",bm2[6]="      ",hm1[6]="      ",hm2[6]="      ",ta[6];
 
 switch (msg)
 {
  case WM_INITDIALOG : SendDlgItemMessage (hwndDlg,103,CB_RESETCONTENT,0,0L);
		       for (i=0;i<12;i++)
                       {
			SendDlgItemMessage (hwndDlg,103,CB_ADDSTRING,0,(LLONG)Mois2[i]);
		       }
		       curtime = time (NULL);
		       tmr = *localtime(&curtime);
                       sprintf (temp,"%i",tmr.tm_year+1900);
		       SetDlgItemText (hwndDlg,102,temp);
		       SendDlgItemMessage (hwndDlg,103,CB_SETCURSEL,tmr.tm_mon,0L);
		       break;	
  case WM_COMMAND :
   switch (wParam)
   {
    case 2:
    case 1 : EndDialog (hwndDlg,0); break;
    case 111 :  GetDlgItemText (hwndDlg,102,temp,99);
		sscanf (temp,"%i",&(tmr.tm_year)); tmr.tm_year = ((tmr.tm_year)>1000)?(tmr.tm_year)-1900:(tmr.tm_year);
		tmr.tm_mon = SendDlgItemMessage (hwndDlg,103,CB_GETCURSEL,0,0L);
		tmr.tm_mday = 1; tmr.tm_hour = 0; tmr.tm_min = 0; tmr.tm_sec = 0;
		debut = (LLONG)mktime (&tmr)-(LLONG)time_of_debut;
		tmr.tm_mon++; if (tmr.tm_mon > 11) {tmr.tm_mon = 0; tmr.tm_year++; }
		fin = (LLONG)mktime (&tmr)-(LLONG)time_of_debut;
		// Calcul des horaires.
    		SetDlgItemText (hwndDlg,101,"");
		dto = dtide (fin+(LLONG)24*3600); hm=bm=Z0; c1=c2=0;
		curtime = (LLONG)mktime (&tmr)-10; curday = (*localtime(&curtime)).tm_mday;
		for (pen=fin+(LLONG)24*3600;pen>debut-(LLONG)24*3600-10;pen-=30)
		{
		 if (((dtn=dtide(pen))*dto)<0)
		 {
		  mm = tide (pen);
		  if ((mm-Z0)<0) { bm = mm; } else { hm = mm; }
		  if ((pen<fin)) 
		  {
		   curtime = (time_t)((LLONG)pen+(LLONG)time_of_debut);
		   tmr=*localtime (&curtime);
		   if (SendDlgItemMessage (hwndDlg,104,BM_GETCHECK,0,0L) == 0)
                   {
		    if (pen > debut)
                    {
		     if ((mm-Z0)<0)
		     {
		      sprintf (temp,"Basse Mer le   %s%i%s \t%i    %2i:%02i.     %.1Lf m.\r\n",Jours[tmr.tm_wday],tmr.tm_mday,Mois[tmr.tm_mon],tmr.tm_year+1900,tmr.tm_hour,tmr.tm_min,bm);
		      fprintf (flog,"%s",temp);
		      SendDlgItemMessage (hwndDlg,101,EM_SETSEL,0,0L);
		      SendDlgItemMessage (hwndDlg,101,EM_REPLACESEL,0,(LLONG)temp);
		     }
		     else
		     {
		      sprintf (temp,"Haute  Mer le   %s%i%s \t%i    %2i:%02i.     %.1Lf m.    Coef %i\r\n",Jours[tmr.tm_wday],tmr.tm_mday,Mois[tmr.tm_mon],tmr.tm_year+1900,tmr.tm_hour,tmr.tm_min,hm,(INT)((hm-bm)/6.01*100.));
		      fprintf (flog, "%s", temp);
		      SendDlgItemMessage (hwndDlg,101,EM_SETSEL,0,0L);
		      SendDlgItemMessage (hwndDlg,101,EM_REPLACESEL,0,(LLONG)temp);
		     }
                    }
		   }
		   else
		   {
		    if ((curday != tmr.tm_mday) && (pen<fin))
		    {
		     sprintf (temp,"%s     %i\t%s  %s  %3i  %3i  %s  %s\r\n",(tmr.tm_wday==6)?Jours2[0]:Jours2[tmr.tm_wday+1],curday,hm2,hm1,(INT)c2,(INT)c1,bm2,bm1);
                     fprintf (flog,"%s",temp);
  		     SendDlgItemMessage (hwndDlg,101,EM_SETSEL,0,0L);
		     SendDlgItemMessage (hwndDlg,101,EM_REPLACESEL,0,(LLONG)temp);
		     for (i=0;i<5;i++) {hm1[i]=hm2[i]=bm1[i]=bm2[i]='-';} c1=c2=0; o=u=0;
                     curday = tmr.tm_mday;
                    }
		    sprintf (ta,"%2i:%02i",tmr.tm_hour,tmr.tm_min);
                    if ((mm-Z0)<0) { if (o==0) {strcpy (bm1,ta); o=1;} else {strcpy (bm2,ta);} }
			      else { if (u==0) {strcpy (hm1,ta); u=1;c1 = (INT)((hm-bm)/6.01*100.);} else {strcpy (hm2,ta); c2 = (INT)((hm-bm)/6.01*100.);} }
		   }
		  }
		 }
                 dto=dtn;
		}
		if (SendDlgItemMessage (hwndDlg,104,BM_GETCHECK,0,0L) != 0)
		{
		 SendDlgItemMessage (hwndDlg,101,EM_SETSEL,0,0L);
		 sprintf(temp,"Jour;HMmatin;HM AM;Coefmatin;CoefAM;BMmatin;BM AM\r\n");
		 fprintf (flog,"%s",temp);
		 SendDlgItemMessage (hwndDlg,101,EM_REPLACESEL,0,(LLONG)temp);
		}
		SendDlgItemMessage (hwndDlg,101,EM_SETSEL,0,0L);
		curtime = (time_t)(debut+(LLONG)time_of_debut);
		tmr = *localtime (&curtime);
		sprintf(temp,"Dtermination des horaires de mare du mois de %s %i\r\n",Mois[tmr.tm_mon],tmr.tm_year+1900);
                fprintf (flog,"%s",temp);
		SendDlgItemMessage (hwndDlg,101,EM_REPLACESEL,0,(LLONG)temp);
		break;
   }
   break;
 }
 return (0);
}

void CalculeHoraires ()
{
 DialogBox (hInst,(LPCSTR)"DLG_HORAIRES",MyWin,(DLGPROC)MakeProcInstance((FARPROC)DialogProcCalcHor,hInst));
}

// OPENONDES : Ouverture fichier d'onde            
void OpenOndes ()
{
 OPENFILENAME op;
 CHAR name[300]="";
 FILE *fin;
 int year;

 op.lStructSize = sizeof(OPENFILENAME);
 op.hwndOwner = MyWin;
 op.hInstance = hInst;
 op.lpstrFilter = (LPCSTR)("Fichier d'ondes\0*.TID\0\0");
 op.lpstrCustomFilter = NULL;
 op.nFilterIndex = 1;
 op.lpstrFile = name;
 op.nMaxFile = 300;
 op.lpstrFileTitle = NULL;
 op.lpstrInitialDir = NULL;
 op.lpstrTitle = "Ouvrir un fichier d'ondes";
 op.Flags = OFN_FILEMUSTEXIST + OFN_PATHMUSTEXIST + OFN_SHOWHELP;
 op.lpstrDefExt = NULL;
 if (GetOpenFileName(&op)!=0)
 {
  strcpy(NameFichierOndes,name);
  if ((fin=fopen(name,"r"))==NULL) { MessageBox (MyWin,"Erreur pendant l'ouverture du fichier","ERROR",MB_OK); }
  else
  { 
   NumOnde = 0;
   fgets (localite,100,fin);
   fscanf (fin,"%i\n",&year);
   YearOfDebut = year;
   rtime.tm_year = year - 1900;
   rtime.tm_mon = 0;
   rtime.tm_mday = 1;
   rtime.tm_hour = 0;
   rtime.tm_min = 0;
   rtime.tm_sec = 0;
   time_of_debut = mktime (&rtime);
   fscanf (fin,"%s\n",name);
   fscanf(fin,"0.0;%Lf;0.0;Niveau Moyen\n",&Z0);
   while (!feof(fin))
   {
    fscanf (fin,"%Lf;%Lf;%Lf;",&ondes[NumOnde].speed,&ondes[NumOnde].ampl,&ondes[NumOnde].etab);
    fgets (ondes[NumOnde].name,100,fin);
    ondes[NumOnde].name[strlen(ondes[NumOnde].name)-1]='\0';
    if (ondes[NumOnde].speed!=0.0)
     {
      ondes[NumOnde].speed=2*M_PI/ondes[NumOnde].speed;
      NumOnde++;
     }
   }
   fclose (fin);
   fprintf (flog,"\Ouverture d'un fichier de composantes d'ondes.\n\n");
  }
 }
 InvalidateRect (MyWin,NULL,TRUE);
 UpdateWindow(MyWin);
}

// OpenEnr : Importe un enregistrement
void OpenEnr ()
{
 OPENFILENAME op;
 CHAR name[300]="";
 FILE *fin;
 op.lStructSize = sizeof(OPENFILENAME);
 op.hwndOwner = MyWin;
 op.hInstance = hInst;
 op.lpstrFilter = (LPCSTR)("Fichier de relev horaires\0*.TXT\0\0");
 op.lpstrCustomFilter = NULL;
 op.nFilterIndex = 1;
 op.lpstrFile = name;
 op.nMaxFile = 300;
 op.lpstrFileTitle = NULL;
 op.lpstrInitialDir = NULL;
 op.lpstrTitle = "Importer un fichier de relev horaires";
 op.Flags = OFN_FILEMUSTEXIST + OFN_PATHMUSTEXIST + OFN_SHOWHELP;
 op.lpstrDefExt = NULL;
 if (GetOpenFileName(&op)!=0)
 {
  strcpy(NameFichierImporter,name);
  init_tab ();
 }
 fprintf (flog,"\nImportation d'un fichier de valeurs\nTime_of_debut = %li\n\n",(LONG)time_of_debut);
 InvalidateRect (MyWin,NULL,TRUE);
 UpdateWindow(MyWin);
}

// SAVEONDES : Enregistrement fichier d'onde
void SaveOndes ()
{
 FILE *fout;
 INT i;
 if ((fout = fopen (NameFichierOndes,"w")) == NULL) { MessageBox (MyWin,"Erreur enregistrement","ERROR",MB_OK); }
 else
 {
  fputs (localite,fout);
  fprintf (fout,"%i\n",YearOfDebut);
  fprintf (fout,"speed;ampl;etab;name\n");
  fprintf (fout,"0.0;%Lf;0.0;Niveau Moyen\n",Z0);
  for (i=0;i<NumOnde;i++)
  {
   fprintf (fout,"%Lf;%Lf;%Lf;%s\n",2*M_PI/ondes[i].speed,ondes[i].ampl,ondes[i].etab,ondes[i].name);
  }
  fclose (fout);
  fprintf (flog,"\nEnregistrement.\n\n");
 }
}

// SAVEASONDES : Enregistrement fichier d'onde sous un autre nom
void SaveAsOndes ()
{
 OPENFILENAME op;
 CHAR name[300]="";
 op.lStructSize = sizeof(OPENFILENAME);
 op.hwndOwner = MyWin;
 op.hInstance = hInst;
 op.lpstrFilter = (LPCSTR)("Fichier d'ondes\0*.TID\0\0");
 op.lpstrCustomFilter = NULL;
 op.nFilterIndex = 1;
 op.lpstrFile = name;
 op.nMaxFile = 300;
 op.lpstrFileTitle = NULL;
 op.lpstrInitialDir = NULL;
 op.lpstrTitle = "Enregistrer un fichier d'ondes";
 op.Flags = OFN_PATHMUSTEXIST + OFN_SHOWHELP;
 op.lpstrDefExt = "TID";
 if (GetSaveFileName(&op)!=0)
 {
  strcpy(NameFichierOndes,name);
  SaveOndes ();
 }
}


// GestionOnde : Modification d'une onde  
BOOL CALLBACK DialogProcPerDea(HWND hwndDlg, UINT msg, WPARAM wParam, LPARAM lParam)
{
 CHAR temp[100];
 switch (msg)
 {
  case WM_COMMAND :
   switch (wParam)
   {
    case 1 : GetDlgItemText (hwndDlg, 101, temp, 99);
	     sscanf (temp, "%Lf", &det_deb);
	     GetDlgItemText (hwndDlg, 102, temp, 99);
	     sscanf (temp, "%Lf", &det_fin); 
    case 2 : EndDialog (hwndDlg, 0); break;
   }
   break;
 }
 return (0);
}

BOOL CALLBACK DialogProcModifier(HWND hwndDlg, UINT msg, WPARAM wParam, LPARAM lParam)
{
 CHAR temp [500];
 switch (msg)
 {
  case WM_INITDIALOG :  SetDlgItemText(hwndDlg,107,ondes[OndeAModifier].name);
			sprintf(temp,"%Lf",(2*M_PI/ondes[OndeAModifier].speed)/3600); SetDlgItemText (hwndDlg, 102,temp);
			sprintf(temp,"%Lf",ondes[OndeAModifier].ampl); SetDlgItemText (hwndDlg, 103,temp);
			sprintf(temp,"%Lf",ondes[OndeAModifier].etab); SetDlgItemText (hwndDlg, 104,temp);
			break;
  case WM_COMMAND : switch (wParam)
   {
    case 1 : GetDlgItemText (hwndDlg, 107,ondes[OndeAModifier].name,99);
	     GetDlgItemText (hwndDlg, 102,temp,99); sscanf (temp,"%Lf",&ondes[OndeAModifier].speed);
	     ondes[OndeAModifier].speed = (ondes[OndeAModifier].speed == 0.0)?1.0e28:2*M_PI/(ondes[OndeAModifier].speed*3600);
	     GetDlgItemText (hwndDlg, 103,temp,99); sscanf (temp,"%Lf",&ondes[OndeAModifier].ampl);
	     GetDlgItemText (hwndDlg, 104,temp,99); sscanf (temp,"%Lf",&ondes[OndeAModifier].etab);
	     sprintf (temp,"L'onde %i a t modifie : \n- Dsignation : %s\n- Priode : %Lf\n- Amplitude : %Lf\n- Etablissement : %Lf\n",OndeAModifier,ondes[OndeAModifier].name,2*M_PI/ondes[OndeAModifier].speed/3600,ondes[OndeAModifier].ampl,ondes[OndeAModifier].etab);
	     MessageBox (hwndDlg,temp,"Modification d'une onde",MB_OK+MB_APPLMODAL+MB_ICONINFORMATION);
	     fprintf (flog,"%s\n\n",temp);
    case 2 : EndDialog (hwndDlg, 0); break;
   }
 }
 return (0);
}

BOOL CALLBACK DialogProcAjouter(HWND hwndDlg, UINT msg, WPARAM wParam, LPARAM lParam)
{
 INT i,j;
 LDOUBLE per;
 CHAR temp[400];
 switch (msg)
 {
  case WM_INITDIALOG :  SendDlgItemMessage (hwndDlg, 104, LB_RESETCONTENT, 0, 0);
  			for (i=0;i<NumOndeAjouter;i++)
			{
			 SendDlgItemMessage (hwndDlg, 104, LB_ADDSTRING,0,(LLONG)(OndeAjouterName[NumOndeImportance[i]]));
			}
			SendDlgItemMessage (hwndDlg, 104, LB_SETCURSEL, 0,0);
                        DialogProcAjouter (hwndDlg,WM_COMMAND,104,0);
			break;
  case WM_COMMAND : switch (wParam)
	{
	 case 1 : GetDlgItemText (hwndDlg,103,temp,99);
		  sscanf (temp,"%Lf",&per);
		  per *= 3600.;
		  ondes[NumOnde] = det_onde_periode (per);
		  GetDlgItemText (hwndDlg,105,ondes[NumOnde].name,99);
		  sprintf (temp,"L'onde suivante a te ajoute :\n - Priode : %Lf\n - Amplitude : %Lf\n - Etablissement : %Lf\n%s\n",per/3600,ondes[NumOnde].ampl,ondes[NumOnde].etab,ondes[NumOnde].name);
                  fprintf (flog,"%s",temp);
		  MessageBox (hwndDlg, temp, "Ajout d'une onde.",MB_OK+MB_APPLMODAL+MB_ICONINFORMATION);
		  NumOnde++;
	 case 2 : EndDialog (hwndDlg,0);
	 case 104 : // ListBox, sans doute une slction, de ttf on change
		    j = SendDlgItemMessage (hwndDlg, 104, LB_GETCURSEL, 0,0);
		    SetDlgItemText (hwndDlg, 105, OndeAjouterName[NumOndeImportance[j]]);
		    sprintf (temp,"%Lf%c",OndeAjouterPeriode[NumOndeImportance[j]],0);
		    SetDlgItemText (hwndDlg, 103, temp);
		    break;
        }

 }
 return (0);
}

BOOL CALLBACK DialogProcGestion(HWND hwndDlg, UINT msg, WPARAM wParam, LPARAM lParam)
{
 INT i,j;
 switch (msg)
 {
  case WM_INITDIALOG :  SendDlgItemMessage (hwndDlg, GO_LISTE, LB_RESETCONTENT, 0, 0);
  			for (i=0;i<NumOnde;i++)
			{
			 SendDlgItemMessage (hwndDlg, GO_LISTE, LB_ADDSTRING,0,(LLONG)&(ondes[i].name));
			}
			SendDlgItemMessage (hwndDlg, GO_LISTE, LB_SETCURSEL, 0,0);
			break;
  case WM_COMMAND : switch (wParam)
	{
         case 2   :
	 case 1   : EndDialog (hwndDlg,0); break;
	 case 101 :  // Ajouter
		    DialogBox (hInst,(LPCSTR)"DLG_AJOUTER",hwndDlg,(DLGPROC)MakeProcInstance((FARPROC)DialogProcAjouter,hInst));
		    DialogProcGestion (hwndDlg,WM_INITDIALOG,0,0);
		    break;
	 case 102 :  // Supprimer
		    if (MessageBox (hwndDlg,"Supprimer cette onde ?","Suppression d'une onde",MB_YESNO+MB_APPLMODAL+MB_ICONQUESTION)==IDNO) { break; };
		    fprintf (flog,"Onde numro %i supprime\n\n",(INT)SendDlgItemMessage (hwndDlg, GO_LISTE, LB_GETCURSEL,0,0));
		    for (i=SendDlgItemMessage (hwndDlg, GO_LISTE, LB_GETCURSEL,0,0);i<NumOnde;i++)
		    {
                     ondes[i] = ondes[i+1];
		    }
		    NumOnde--;
		    DialogProcGestion (hwndDlg,WM_INITDIALOG,0,0);
		    break;
	 case 103 :  // Modifier
		    OndeAModifier = SendDlgItemMessage (hwndDlg, GO_LISTE, LB_GETCURSEL,0,0);
		    DialogBox (hInst,(LPCSTR)"DLG_MODIF",hwndDlg,(DLGPROC)MakeProcInstance((FARPROC)DialogProcModifier,hInst));
		    DialogProcGestion (hwndDlg,WM_INITDIALOG,0,0);
		    break;

        }
 }
 return (0);
}

void GestionOndes ()
{
 DialogBox (hInst,(LPCSTR)"DLG_ONDES",MyWin,(DLGPROC)MakeProcInstance((FARPROC)DialogProcGestion,hInst));
 InvalidateRect (MyWin,NULL,TRUE);
 UpdateWindow(MyWin);
}

// GPTime : GetPaintTime Fonction d'aide au trac de la mare.
LDOUBLE GPTime (LLONG i)
{
 LLONG GSPVert,GSPHorz;
 LLONG res;
 GSPVert = GetScrollPos(MyWin,SB_VERT);
 GSPHorz = GetScrollPos(MyWin,SB_HORZ);
 res = i*GSPVert+GSPHorz*(((LDOUBLE)NUMJOURS*24.*3600.-(LDOUBLE)(LARGX-SCROLLBAR)*GSPVert))/10000.;
 return ((LDOUBLE)res);
}

LDOUBLE GPTimeRender (LLONG i)
{
 LLONG GSPHorz;
 LLONG res;
 GSPHorz = GetScrollPos(MyWin,SB_HORZ);
 res = i*3600*24/LARGX+GSPHorz*3600.*24.;
 return ((LDOUBLE)res);
}

// Procedure de gestion de la fenetre Windows
LLONG FAR PASCAL _export MainWndProc(HWND hWnd, unsigned message,WORD wParam, LLONG lParam)
{
 RECT rTemp;    
 HDC hdc;       
 PAINTSTRUCT ps;
 struct tm tmtemp;
 LLONG h,hh,hhh,i;
 LDOUBLE dtn,dto;
 CHAR st [80],st2 [80];
 BOOL asc;
 switch (message)
 {
  case WM_CREATE : (DefWindowProc(hWnd, message, wParam, lParam));
		   for (i=0;i<640;i++)
		   {
		    screen[i]=0;
		   }
  case WM_PAINT:
	  hdc=BeginPaint(hWnd,&ps);
	  switch (Action)
          {
	   case DETPERIODE :
		     for (i=0;i<LARGX;i++)
		     {
		      LineTo(hdc,i,screen[i]);
		     }
                     break;	
	   case DETONDE :    	// Achtung !!!!!! (normal : n dessous detperiode)
	   case GRAPHTIDE :
		     if (ok_tab == TRUE)
		     {
		      if (GTWhat == GT_RENDER)
		      {
		       SelectObject (hdc,hPBlue); // Bleu : Mare Calcule
		       MoveTo (hdc,0,MILY-HAUTMENU);
		       for (i=0;i<LARGX+1;i++)
		        {
			 LineTo(hdc,i,HAUTY-(INT)((tide(GPTimeRender(i)+(LLONG)decal_time)-Z0)*COEFY+MILY));
			}
		       h = 3600.*24./LARGX;
		       hh = (GetScrollPos(MyWin,SB_HORZ)*3600.*24.);
		       hh = ((LLONG)(hh/60))*60;
		       SelectObject (hdc,hPBlack);
		       for (i=0+hh;i<(LLONG)(LARGX+1)*h+hh;i+=60)      // Pb avec hh
		       {
			MoveTo(hdc,(LLONG)((i-hh)/h),420);
			if ((h<500) &&((ldiv(i,60*10)).rem==0)) { MoveTo(hdc,(LLONG)((i-hh)/h),HAUTY-HAUTMENU-SCROLLBAR); LineTo(hdc,(LLONG)((i-hh)/h),HAUTY-HAUTMENU-SCROLLBAR-1); }
			if ((h<1000) && ((ldiv(i,60*60)).rem==0)) { MoveTo(hdc,(LLONG)((i-hh)/h),HAUTY-HAUTMENU-SCROLLBAR); LineTo(hdc,(LLONG)((i-hh)/h),HAUTY-HAUTMENU-SCROLLBAR-3); }
			if ((ldiv(i,(LLONG)60*60*24)).rem==0) { MoveTo(hdc,(LLONG)((i-hh)/h),HAUTY-HAUTMENU-SCROLLBAR); LineTo(hdc,(LLONG)((i-hh)/h),HAUTY-HAUTMENU-SCROLLBAR-8); }
			if ((ldiv(i,(LLONG)30*60*60*24).rem)==0) { LineTo(hdc,(LLONG)((i-hh)/h),HAUTY-HAUTMENU-SCROLLBAR-15); }
		       }
		       // Trac chelle ordonne
		       if (AxeHauteur == TRUE)
		       {
			SelectObject (hdc,hPBlack);
			for (i=0;i<801;i+=10) { h =HAUTY-(INT)(((float)i/100-Z0)*COEFY+MILY); MoveTo (hdc,2,h); LineTo (hdc,3,h); }
			for (i=0;i<801;i+=100){ h =HAUTY-(INT)(((float)i/100-Z0)*COEFY+MILY); MoveTo (hdc,2,h); LineTo (hdc,6,h); }
			TextOut (hdc,2,360,"0m",2);
                        TextOut (hdc,2,95,"8m",2);
		       }
		       // Ecriture des heures
		       if (AxeTemps == TRUE)
                       {
			worktime = (time_t)((LLONG)(time_of_debut + decal_time)+hh);
		        tmtemp=*(localtime (&worktime));
                       }
		       sprintf(st,"%s%i%s %i",Jours[tmtemp.tm_wday],tmtemp.tm_mday,Mois[tmtemp.tm_mon],tmtemp.tm_year+1900);
		       TextOut (hdc,LARGX/2-80,5,st,strlen (st));
		       // Determination des hautes et basses mers.
		       /*
		       i = hh;
		       for (h = (LLONG)hh;h < ((LLONG)hh + (LLONG)3600*25);h+=(LLONG)10)
		       {
			if (((hhh=det_maree (h))-i)>120)
                        {
			 if ((hhh>hh) && (hhh<(LLONG)(hh+(LLONG)3600*24)))
			 {
			  i=hhh;
			  hhh+=(LLONG)(time_of_debut + decal_time);
			  tmtemp=*(localtime (&(time_t)(hhh)));
			  sprintf(st,"%2i:%2i",tmtemp.tm_hour,tmtemp.tm_min);
			  TextOut (hdc,(INT)(((tmtemp.tm_hour*60.+tmtemp.tm_min)/(60.*24.))*LARGX-20),HAUTY-((tide(i)-Z0)*COEFY+MILY)+(((tide(i)-Z0)<0)?10:-30),st,strlen (st));
			 }
                        }
		       }
		       */
                       hh+=decal_time;
		       if (Horaires == TRUE)
                       {
		        dto = tide (hh);
		        dtn = tide (hh+10);
                        if ((dtn-dto)>0) { asc = TRUE; } else { asc = FALSE; }
			for (h = (LLONG)hh;h < ((LLONG)hh + (LLONG)3600*24);h+=(LLONG)10)
		        {
                         dtn = tide (h);
		       	 if ( ((dto>dtn) && (asc==TRUE)) || ((dtn>dto) && (asc==FALSE)) ) 
		         {
                          asc = (asc==FALSE)?TRUE:FALSE; 
                          hhh = h;
			  hhh+=(LLONG)(time_of_debut + decal_time);
			  tmtemp=*(localtime (&(time_t)(hhh)));
			  sprintf(st,"%2i:%02i",tmtemp.tm_hour,tmtemp.tm_min);
			  TextOut (hdc,(INT)((((h-hh)/60)/(60.*24.))*LARGX-15),HAUTY-((tide(h)-Z0)*COEFY+MILY)+(((tide(h)-Z0)<0)?10:-30),st,strlen (st));
			 }
                         dto = dtn;
			}
                       }
		      }
		      else
                      {
		       if ((GTWhat == GT_ENR) || (GTWhat == GT_ALL))
		       {
			SelectObject (hdc,hPGreen);  // Vert : Mare source
			MoveTo (hdc,0,MILY-HAUTMENU);
			for (i=0;i<LARGX-SCROLLBAR+1;i++)
			 {
			  LineTo(hdc,i,HAUTY-(INT)((tide_load(GPTime(i)+(LLONG)decal_time,0)-Z0)*COEFY+MILY));
			 }
		       }
		       if ((GTWhat ==  GT_PREDICT) || (GTWhat == GT_ALL))
		       {
			SelectObject (hdc,hPBlue); // Bleu : Mare Calcule
			MoveTo (hdc,0,MILY-HAUTMENU);
			for (i=0;i<LARGX-SCROLLBAR+1;i++)
			 {
			  LineTo(hdc,i,HAUTY-(INT)((tide(GPTime(i)+(LLONG)decal_time)-Z0)*COEFY+MILY));
			 }
		       }
		       if ((GTWhat == GT_ALL))
		       {
			SelectObject (hdc,hPRed); // Rouge : Vert -Bleu
			MoveTo (hdc,0,MILY-HAUTMENU);
			for (i=0;i<LARGX-SCROLLBAR+1;i++)
			 {
			  h=GPTime(i)+(LLONG)decal_time;
			  LineTo(hdc,i,HAUTY-(INT)(((tide_load(h,0)-tide(h)))*COEFY+MILY));
			 }
			MoveTo (hdc,0,MILY-HAUTMENU+20);
			LineTo (hdc,LARGX-SCROLLBAR,MILY-HAUTMENU+20);
		       }
		       // Trac de l'Echelle 1 trait de 15 par mois de 10 par jour de 5 par heure
		       //		 et de 2 par dix minutes et de 1 par minute
		       if (AxeTemps == TRUE)
                       {
		        h = GetScrollPos (MyWin,SB_VERT);
		        hh = (GetScrollPos(MyWin,SB_HORZ)*(((LDOUBLE)NUMJOURS*24.*3600.-(LDOUBLE)(LARGX-SCROLLBAR)*GetScrollPos(MyWin,SB_VERT))/10000.));
			hh = ((LLONG)(hh/60))*60;
			SelectObject (hdc,hPBlack);
			for (i=0+hh;i<(LLONG)(LARGX-SCROLLBAR+1)*h+hh;i+=60)      // Pb avec hh
		        {
			 MoveTo(hdc,(LLONG)((i-hh)/h),420);
			 if ((h<500) &&((ldiv(i,60*10)).rem==0)) { MoveTo(hdc,(LLONG)((i-hh)/h),HAUTY-HAUTMENU-SCROLLBAR); LineTo(hdc,(LLONG)((i-hh)/h),HAUTY-HAUTMENU-SCROLLBAR-1); }
			 if ((h<1000) && ((ldiv(i,60*60)).rem==0)) { MoveTo(hdc,(LLONG)((i-hh)/h),HAUTY-HAUTMENU-SCROLLBAR); LineTo(hdc,(LLONG)((i-hh)/h),HAUTY-HAUTMENU-SCROLLBAR-3); }
			 if ((ldiv(i,(LLONG)60*60*24)).rem==0) { MoveTo(hdc,(LLONG)((i-hh)/h),HAUTY-HAUTMENU-SCROLLBAR); LineTo(hdc,(LLONG)((i-hh)/h),HAUTY-HAUTMENU-SCROLLBAR-8); }
			 if ((ldiv(i,(LLONG)30*60*60*24).rem)==0) { LineTo(hdc,(LLONG)((i-hh)/h),HAUTY-HAUTMENU-SCROLLBAR-15); }
		        }
		        // Ecriture des heures
			worktime =(time_t)((LLONG)(time_of_debut + decal_time)+hh); TextOut (hdc,22,5,ctime(&worktime),24);
			worktime =(time_t)((LLONG)(time_of_debut + decal_time)+hh+(LARGX-SCROLLBAR)*h); TextOut (hdc,LARGX-SCROLLBAR-170,5,ctime(&worktime),24);
		        TextOut (hdc,2,5,"de ",3);
			TextOut (hdc,LARGX-SCROLLBAR-170-15,5," ",2);
		       }
		       // Trac chelle ordonne
		       if (AxeHauteur == TRUE)
		       {
			SelectObject (hdc,hPBlack);
			for (i=0;i<801;i+=10) { h =HAUTY-(INT)(((FLOAT)i/100-Z0)*COEFY+MILY); MoveTo (hdc,2,h); LineTo (hdc,3,h); }
			for (i=0;i<801;i+=100){ h =HAUTY-(INT)(((FLOAT)i/100-Z0)*COEFY+MILY); MoveTo (hdc,2,h); LineTo (hdc,6,h); }
			TextOut (hdc,2,360,"0m",2);
                        TextOut (hdc,2,95,"8m",2);
		       }
		      }
		     }
		     else
		     {
		      MoveTo (hdc,0,0);
		      LineTo (hdc,LARGX,HAUTY);
		     }
		     break;
           }
	  EndPaint(hWnd,&ps);
	  break;
  case WM_HSCROLL:
	  switch (wParam)
	  {
	   case SB_BOTTOM : SetScrollPos (MyWin,SB_HORZ,10000,TRUE); break;
	   case SB_LINEDOWN : SetScrollPos (MyWin,SB_HORZ,GetScrollPos (MyWin,SB_HORZ)+(1),TRUE); break;
	   case SB_LINEUP : SetScrollPos (MyWin,SB_HORZ,GetScrollPos (MyWin,SB_HORZ)-(1),TRUE); break;
	   case SB_PAGEDOWN : SetScrollPos (MyWin,SB_HORZ,GetScrollPos (MyWin,SB_HORZ)+(30),TRUE); break;
	   case SB_PAGEUP : SetScrollPos (MyWin,SB_HORZ,GetScrollPos (MyWin,SB_HORZ)-(30),TRUE); break;
	   case SB_TOP : SetScrollPos (MyWin,SB_HORZ,0,TRUE); break;
	   case SB_THUMBTRACK : 
	   case SB_THUMBPOSITION : SetScrollPos (MyWin,SB_HORZ,LOWORD(lParam),TRUE); break;
	  }
	InvalidateRect (MyWin,NULL,TRUE);
	UpdateWindow(MyWin);
	break;
  case WM_VSCROLL:
	  switch (wParam)
	  {
	   case SB_BOTTOM : SetScrollPos (MyWin,SB_VERT,10000,TRUE); break;
	   case SB_LINEDOWN : SetScrollPos (MyWin,SB_VERT,GetScrollPos (MyWin,SB_VERT)+(1),TRUE); break;
	   case SB_LINEUP : SetScrollPos (MyWin,SB_VERT,GetScrollPos (MyWin,SB_VERT)-(1),TRUE); break;
	   case SB_PAGEDOWN : SetScrollPos (MyWin,SB_VERT,GetScrollPos (MyWin,SB_VERT)+(30),TRUE); break;
	   case SB_PAGEUP : SetScrollPos (MyWin,SB_VERT,GetScrollPos (MyWin,SB_VERT)-(30),TRUE); break;
	   case SB_TOP : SetScrollPos (MyWin,SB_VERT,0,TRUE); break;
	   case SB_THUMBTRACK : 
	   case SB_THUMBPOSITION : SetScrollPos (MyWin,SB_VERT,LOWORD(lParam),TRUE); break;
	  }
	InvalidateRect (MyWin,NULL,TRUE);
	UpdateWindow(MyWin);
	break;
  case WM_COMMAND:
	  switch(wParam)
	  {
		  case CM_OPENONDES : OpenOndes (); break;
		  case CM_SAVEONDES : SaveOndes (); break;
		  case CM_SAVEASONDES : SaveAsOndes (); break;
		  case CM_OPENENR : OpenEnr ();   break;
		  case CM_EXIT:  DestroyWindow(hWnd);  break;
                  case CM_GT_HORAIRES : CalculeHoraires (); break;
		  case CM_GRAPHTIDE :
		  case CM_GT_RENDER : SetScrollRange (hWnd,SB_HORZ,0,NUMJOURS,TRUE);
				      SetScrollPos (hWnd,SB_HORZ,0,TRUE);
				      SetScrollRange (hWnd,SB_VERT,0,0,TRUE);
		  case CM_GT_PREDICT:
		  case CM_GT_ENR    :
		  case CM_GT_ALL    :
                                decal_time=0;
				if (wParam != CM_GT_RENDER)
                                {
				 SetScrollRange (hWnd,SB_HORZ,0,10000,TRUE);
				 SetScrollPos (hWnd,SB_HORZ,0,TRUE);
				 SetScrollRange (hWnd,SB_VERT,60,10000,TRUE);
				 SetScrollPos (hWnd,SB_VERT,100,TRUE);
				}
				Action = GRAPHTIDE;
				GTWhat = wParam - CM_GRAPHTIDE - 1;
				InvalidateRect (MyWin,NULL,TRUE);
				UpdateWindow(MyWin);
				actionmaker();
				break;
		  case CM_GT_ASUIV : decal_time = (time_t)((LLONG)decal_time + (LLONG)365*24*3600); InvalidateRect (MyWin,NULL,TRUE); UpdateWindow(MyWin);break;
		  case CM_GT_APREC : decal_time = (time_t)((LLONG)decal_time - (LLONG)365*24*3600); InvalidateRect (MyWin,NULL,TRUE); UpdateWindow(MyWin);break;
		  case CM_GEST : GestionOndes (); break;
		  case CM_REINIT : NumOnde = 0;
                  		   fprintf (flog,"\n\nRinitialisation\n\n");
		  		   InvalidateRect (MyWin,NULL,TRUE);
				   UpdateWindow(MyWin);
				   break;
		  case CM_DETNIV :
				det_niv ();
				InvalidateRect (MyWin,NULL,TRUE);
				UpdateWindow(MyWin);
				break;
		  case CM_DETONDE :
		  case CM_DETLUNE1   :
		  case CM_DETSOLEIL1 :
		  case CM_DETELLI1   :
		  case CM_DETLUNE2   :
                  case CM_DETSOLEIL2 :
			       /*	SetScrollRange (hWnd,SB_HORZ,0,0,TRUE);
				SetScrollRange (hWnd,SB_VERT,0,0,TRUE);*/
				NumOndeBis = wParam - CM_DETONDE - 1;
				Action = DETONDE;
				actionmaker();
				InvalidateRect (MyWin,NULL,TRUE);
				UpdateWindow(MyWin);
				break;
		  case CM_DETTOUT : for (i=0;i<5;i++) {NumOndeBis = i; Action = DETONDE; actionmaker ();}
				    InvalidateRect (MyWin,NULL,TRUE);
				    UpdateWindow(MyWin);
				    break;
 		  case CM_DETTOUTAFOND : for (i=0;i<NumOndeAjouter;i++) { det_onde_num_tout (i); }
				    InvalidateRect (MyWin,NULL,TRUE);
				    UpdateWindow(MyWin);
				    break;

		  case CM_FFT_MAXP : det_periode_fft (); InvalidateRect (MyWin,NULL,TRUE); UpdateWindow(MyWin);  break;
		  case CM_DETPERIODE :
		  case CM_PER1:
		  case CM_PER2:
		  case CM_PER3:
                  case CM_PER4:
				SetScrollRange (hWnd,SB_HORZ,0,0,TRUE);
				SetScrollRange (hWnd,SB_VERT,0,0,TRUE);
				det_deb = det_deb_tab [wParam - CM_DETPERIODE - 1];
				det_fin = det_fin_tab [wParam - CM_DETPERIODE - 1];
				Action = DETPERIODE;
				actionmaker();
				InvalidateRect (MyWin,NULL,TRUE);
				UpdateWindow(MyWin);
				break;
		  case CM_PER5 :
			     	SetScrollRange (hWnd,SB_HORZ,0,0,TRUE); 	 
				SetScrollRange (hWnd,SB_VERT,0,0,TRUE);
				Action = DETPERIODE;
				DialogBox (hInst,(LPCSTR)"DLG_PER_DEA",MyWin,(DLGPROC)MakeProcInstance((FARPROC)DialogProcPerDea,hInst));
				actionmaker();
				InvalidateRect (MyWin,NULL,TRUE);
				UpdateWindow(MyWin);
				break;
		  case CM_AXETEMPS : AxeTemps = !AxeTemps; CheckMenuItem(GetSubMenu(GetMenu(MyWin),3),GetMenuItemID(GetSubMenu(GetMenu(MyWin),3),0),AxeTemps?MF_CHECKED:MF_UNCHECKED);
  				     InvalidateRect (MyWin,NULL,TRUE);
				     UpdateWindow(MyWin);
				     break;
		  case CM_AXEHAUTEUR : AxeHauteur = !AxeHauteur; CheckMenuItem(GetSubMenu(GetMenu(MyWin),3),GetMenuItemID(GetSubMenu(GetMenu(MyWin),3),1),AxeHauteur?MF_CHECKED:MF_UNCHECKED);
				     InvalidateRect (MyWin,NULL,TRUE);
				     UpdateWindow(MyWin);
				     break;
		  case CM_HORAIRES : Horaires = !Horaires; CheckMenuItem(GetSubMenu(GetMenu(MyWin),3),GetMenuItemID(GetSubMenu(GetMenu(MyWin),3),2),Horaires?MF_CHECKED:MF_UNCHECKED);
				     InvalidateRect (MyWin,NULL,TRUE);
				     UpdateWindow(MyWin);
				     break;
		  case CM_FOURIER : CFourier = !CFourier; CheckMenuItem(GetSubMenu(GetMenu(MyWin),3),GetMenuItemID(GetSubMenu(GetMenu(MyWin),3),4),CFourier?MF_CHECKED:MF_UNCHECKED);
				     InvalidateRect (MyWin,NULL,TRUE);
				     UpdateWindow(MyWin);
				     break;
		  case CM_SOURCE :
		  case CM_SENR : Source = ENREG;
		  case CM_STIDE : Source = MBRUTE;
		  case CM_SRTIDE : Source = MRECTIF;
		  case CM_SATIDE : Source = MABRUTE;
		  case CM_SRATIDE : Source = MARECTIF;
			 Source = (sources)(wParam - CM_SOURCE - 1);
			 actionmaker();
    			 InvalidateRect (MyWin,NULL,TRUE);
			 UpdateWindow(MyWin);
			 break;
		  case CM_VER_FFT : Ver_FFT = !Ver_FFT; break;
                  case CM_CONV : Conv (); break;
		  case CM_AINDEX :
		  case CM_ASOMMAIRE : WinHelp (MyWin, "WTIDE.HLP",HELP_CONTENTS,0L); break;
		  case CM_AAPROPOS : MessageBox (MyWin, "MareEtude v1.0\n\nProgramme de prdiction de mare\n\nDvelopp  l'occasion d'un TIPE 1999.\nEcrit par Rmi PEYRONNET\n","A Propos de MareEtude",MB_OK+MB_APPLMODAL+MB_ICONINFORMATION); break;
		  default: break;
	  }
	  break;

  case WM_QUIT:
  case WM_DESTROY:  PostQuitMessage(0);  break;
  default: return (DefWindowProc(hWnd, message, wParam, lParam));
 }
 return (NULL);
}


// Procedure d'initiation de l'application Windows 
BOOL InitApplication(HINSTANCE hInstance)
{
 WNDCLASS  wc;
 wc.style = CS_HREDRAW | CS_VREDRAW;
 wc.lpfnWndProc = (long (pascal *)(const HWND__ near*,unsigned int,unsigned int,long))MainWndProc;
 wc.cbClsExtra = 0;
 wc.cbWndExtra = 0;                      
 wc.hInstance = hInstance;
 wc.hIcon = LoadIcon(hInstance, "MAREE1");
 wc.hCursor = LoadCursor(NULL, IDC_ARROW);
 wc.hbrBackground = (HBRUSH)GetStockObject(WHITE_BRUSH);
 wc.lpszMenuName = "MAREEMENU";
 wc.lpszClassName = "MAREE";
 return (RegisterClass(&wc));
}

// Procedure d'initiation de la fenetre Windows
HWND InitInstance(HINSTANCE hInstance, INT nCmdShow)
{
 HWND	hWnd, hList;
 hInst = hInstance;
 hWnd = CreateWindow("MAREE","Mare Etude. TIPE - Rmi Peyronnet 1999.",WS_OVERLAPPED+WS_MINIMIZEBOX+WS_SYSMENU+WS_CAPTION,CW_USEDEFAULT, CW_USEDEFAULT,
 		640, 480, NULL, NULL, hInstance, NULL );
 if (!hWnd) return (hWnd);
#if ACTION == GRAPHTIDE
 SetScrollRange (hWnd,SB_HORZ,0,10000,TRUE);
 SetScrollPos (hWnd,SB_HORZ,0,TRUE);  
 SetScrollRange (hWnd,SB_VERT,60,10000,TRUE);
 SetScrollPos (hWnd,SB_VERT,100,TRUE);
#endif
 ShowWindow(hWnd,SW_SHOW);
 UpdateWindow(hWnd);
 return (hWnd);	
}

// Procedure de boucle Windows
INT WinRun ()
{
 MSG msg;
 while (GetMessage(&msg, NULL,NULL,NULL))
  {
   TranslateMessage(&msg);
   DispatchMessage(&msg);
  }
 return (msg.wParam);
}

// Procedure Principale pour Windows
INT PASCAL WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance,LPSTR lpCmdLine, INT nCmdShow)
{
 if ((flog = fopen (LOGNAME,"wt")) == NULL) { MessageBox (NULL,"Impossible d'ouvrir le fichier MarEtud.LOG","Erreur",MB_OK);}
 if ((LoadLibrary("BWCC.DLL"))<HINSTANCE_ERROR) { MessageBox (NULL,"Impossible d'ouvrir la bibliothque BWCC.DLL","Erreur",MB_OK); }
 MessageBox(NULL,"Bienvenue  MareEtude\nprogramme de prdiction de mare\ndvelopp  l'occasion d'un TIPE 1999.","Bienvenue  MareEtude (TIPE - Rmi PEYRONNET 1999).\n\n",MB_OK+MB_APPLMODAL+MB_ICONINFORMATION);
 fprintf (flog,"Bienvenue  MareEtude (TIPE - Rmi PEYRONNET 1999).\n\n");
 ok_tab = FALSE;
 hPRed = CreatePen (PS_SOLID,0,RGB(255,0,0));
 hPGreen = CreatePen (PS_SOLID,0,RGB(0,255,0));
 hPBlue = CreatePen (PS_SOLID,0,RGB(0,0,255));
 hPBlack = CreatePen (PS_SOLID,0,RGB(0,0,0));
 if (!hPrevInstance) if (!InitApplication(hInstance))	return (FALSE);
 if (!(MyWin=InitInstance(hInstance, nCmdShow)))	return (FALSE);
 main2();
 InvalidateRect (MyWin,NULL,TRUE);
 UpdateWindow(MyWin);
 SendMessage (MyWin,WM_COMMAND,CM_DETTOUT,0L);
 WinRun();
 fclose (flog);
 return 0;
}
